import { Injectable, NgModule, Component, Input, defineInjectable } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormArray, FormControl, FormGroup, FormsModule, Validators } from '@angular/forms';
import { catchError, map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxValidateService = /** @class */ (function () {
    function NgxValidateService() {
    }
    /**
     * This method will mark each formControl in the form as touched.
     * */
    /**
     * This method will mark each formControl in the form as touched.
     *
     * @param {?} formGroup
     * @return {?}
     */
    NgxValidateService.prototype.validateAllFormFields = /**
     * This method will mark each formControl in the form as touched.
     *
     * @param {?} formGroup
     * @return {?}
     */
    function (formGroup) {
        var _this = this;
        Object.keys(formGroup.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            /** @type {?} */
            var control = formGroup.get(field);
            if (control instanceof FormControl) {
                control.markAsTouched({ onlySelf: true });
            }
            else if (control instanceof FormGroup) {
                _this.validateAllFormFields(control);
            }
            else if (control instanceof FormArray) {
                control.controls.map((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) {
                    _this.validateAllFormFields(c);
                }));
            }
        }));
    };
    NgxValidateService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxValidateService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxValidateService.ngInjectableDef = defineInjectable({ factory: function NgxValidateService_Factory() { return new NgxValidateService(); }, token: NgxValidateService, providedIn: "root" });
    return NgxValidateService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ValidationErrorComponent = /** @class */ (function () {
    function ValidationErrorComponent() {
    }
    /**
     * @return {?}
     */
    ValidationErrorComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.control) {
            this.control = new FormControl();
        }
    };
    ValidationErrorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'validation-error',
                    template: "<div *ngIf=\"control?.touched\">\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('required')\">Field is required</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('email')\">The email is invalid</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('min')\">The field is too small</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('max')\">The field is too large</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('minlength')\">The field is too short</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('maxlength')\">The field is too long</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('isNumberError')\">Only number or '+' or '-' or '.' allowed</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('strongPasswordError')\">The password is not strong enough</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('matchPasswordError')\">The password is not match</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('numberLetterOnlyError')\">The field allows number or letter only</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('numberLetterSpace')\">The field allows space or letter only</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('noBlankError')\">The field should not contain blank</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('duplicateError')\">The field duplicate with server</p>\n  <p [ngClass]=\"errorClass\" *ngIf=\"control.hasError('isUrlError')\">The field should be url</p>\n</div>\n"
                }] }
    ];
    /** @nocollapse */
    ValidationErrorComponent.ctorParameters = function () { return []; };
    ValidationErrorComponent.propDecorators = {
        control: [{ type: Input }],
        errorClass: [{ type: Input }]
    };
    return ValidationErrorComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxValidateModule = /** @class */ (function () {
    function NgxValidateModule() {
    }
    NgxValidateModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        ValidationErrorComponent,
                    ],
                    imports: [
                        CommonModule,
                        FormsModule
                    ],
                    exports: [
                        ValidationErrorComponent
                    ]
                },] }
    ];
    return NgxValidateModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} obj
 * @return {?}
 */
function isPresent(obj) {
    return obj !== undefined && obj !== null;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// https://github.com/ng-packagr/ng-packagr/issues/696
// @dynamic
var  
// https://github.com/ng-packagr/ng-packagr/issues/696
// @dynamic
NgxValidators = /** @class */ (function () {
    function NgxValidators() {
    }
    /**
     * Test if the input is number.
     * Allow only number or + or - or .
     * If not number, return isNumberError object.
     * */
    /**
     * Test if the input is number.
     * Allow only number or + or - or .
     * If not number, return isNumberError object.
     *
     * @param {?} control
     * @return {?}
     */
    NgxValidators.isNumber = /**
     * Test if the input is number.
     * Allow only number or + or - or .
     * If not number, return isNumberError object.
     *
     * @param {?} control
     * @return {?}
     */
    function (control) {
        /** @type {?} */
        var customRegexp = /^[\-\+]?[0-9]*(\.[0-9]+)?$/;
        if (control.value && !customRegexp.test(control.value)) {
            return { isNumberError: true };
        }
    };
    /**
     * Test if the password strong enough.
     * Password should contain number and uppercase letter and lower case letter and length should more than 7
     * If not strong enough, return strongPasswordError object.
     * */
    /**
     * Test if the password strong enough.
     * Password should contain number and uppercase letter and lower case letter and length should more than 7
     * If not strong enough, return strongPasswordError object.
     *
     * @param {?} control
     * @return {?}
     */
    NgxValidators.strongPassword = /**
     * Test if the password strong enough.
     * Password should contain number and uppercase letter and lower case letter and length should more than 7
     * If not strong enough, return strongPasswordError object.
     *
     * @param {?} control
     * @return {?}
     */
    function (control) {
        /** @type {?} */
        var hasNumber = /\d/.test(control.value);
        /** @type {?} */
        var hasUpper = /[A-Z]/.test(control.value);
        /** @type {?} */
        var hasLower = /[a-z]/.test(control.value);
        /** @type {?} */
        var valid = hasNumber && hasUpper && hasLower && control.value.length > 7;
        if (!valid) {
            // return what´s not valid
            return { strongPasswordError: true };
        }
        return null;
    };
    /**
     * Compare two password to validate if they are match
     * If not match, return matchPasswordError object.
     * */
    /**
     * Compare two password to validate if they are match
     * If not match, return matchPasswordError object.
     *
     * @param {?} repeatPassword
     * @return {?}
     */
    NgxValidators.matchPassword = /**
     * Compare two password to validate if they are match
     * If not match, return matchPasswordError object.
     *
     * @param {?} repeatPassword
     * @return {?}
     */
    function (repeatPassword) {
        /** @type {?} */
        var thisControl;
        /** @type {?} */
        var inputControl;
        return (/**
         * @param {?} control
         * @return {?}
         */
        function validate(control) {
            if (!control.parent) {
                return null;
            }
            // Initializing the validator.
            if (!thisControl) {
                thisControl = control;
                inputControl = (/** @type {?} */ (control.parent.get(repeatPassword)));
                if (!inputControl) {
                    throw new Error('matchOtherValidator(): other control is not found in parent group');
                }
                inputControl.valueChanges.subscribe((/**
                 * @return {?}
                 */
                function () {
                    thisControl.updateValueAndValidity();
                }));
            }
            if (!inputControl) {
                return null;
            }
            if (inputControl.value !== thisControl.value) {
                return { matchPasswordError: true };
            }
            return null;
        });
    };
    /**
     * This control is required if the input control has value.
     * */
    /**
     * This control is required if the input control has value.
     *
     * @param {?} inputControlName
     * @return {?}
     */
    NgxValidators.requiredIfInputHasValue = /**
     * This control is required if the input control has value.
     *
     * @param {?} inputControlName
     * @return {?}
     */
    function (inputControlName) {
        /** @type {?} */
        var thisControl;
        /** @type {?} */
        var inputControl;
        return (/**
         * @param {?} control
         * @return {?}
         */
        function validate(control) {
            if (!control.parent) {
                return null;
            }
            // Initializing the validator.
            if (!thisControl) {
                thisControl = control;
                inputControl = (/** @type {?} */ (control.parent.get(inputControlName)));
                if (!inputControl) {
                    throw new Error('matchOtherValidator(): other control is not found in parent group');
                }
                inputControl.valueChanges.subscribe((/**
                 * @return {?}
                 */
                function () {
                    thisControl.updateValueAndValidity();
                }));
            }
            if (!inputControl) {
                return null;
            }
            if (inputControl.value && !thisControl.value) {
                return {
                    required: true
                };
            }
            return null;
        });
    };
    /**
     * only allow letters/numbers
     * */
    /**
     * only allow letters/numbers
     *
     * @param {?} control
     * @return {?}
     */
    NgxValidators.numberLetterOnly = /**
     * only allow letters/numbers
     *
     * @param {?} control
     * @return {?}
     */
    function (control) {
        /** @type {?} */
        var regexp = /^[a-zA-Z0-9]*$/;
        if (control.value && !regexp.test(control.value)) {
            return { numberLetterOnlyError: true };
        }
    };
    /**
     * only allow letters/numbers/space
     * */
    /**
     * only allow letters/numbers/space
     *
     * @param {?} control
     * @return {?}
     */
    NgxValidators.numberLetterSpaceOnly = /**
     * only allow letters/numbers/space
     *
     * @param {?} control
     * @return {?}
     */
    function (control) {
        /** @type {?} */
        var regexp = /^[A-Za-z0-9 _]*$/;
        if (control.value && !regexp.test(control.value)) {
            return { numberLetterSpace: true };
        }
    };
    /**
     * should not contain blank
     * */
    /**
     * should not contain blank
     *
     * @param {?} control
     * @return {?}
     */
    NgxValidators.noBlank = /**
     * should not contain blank
     *
     * @param {?} control
     * @return {?}
     */
    function (control) {
        /** @type {?} */
        var pattern = '\\s';
        if (new RegExp(pattern).test(control.value)) {
            return { 'noBlankError': true };
        }
        return undefined;
    };
    /**
     * Validate from backend if this field is duplicate or not.
     * Input url string and HttpClient and the validator will get to your url,
     * if the response is equal to true -> not duplicate
     * if the response is not equal to true -> duplicate
     * */
    /**
     * Validate from backend if this field is duplicate or not.
     * Input url string and HttpClient and the validator will get to your url,
     * if the response is equal to true -> not duplicate
     * if the response is not equal to true -> duplicate
     *
     * @param {?} url
     * @param {?} http
     * @param {?} expectValue
     * @return {?}
     */
    NgxValidators.asyncDuplicate = /**
     * Validate from backend if this field is duplicate or not.
     * Input url string and HttpClient and the validator will get to your url,
     * if the response is equal to true -> not duplicate
     * if the response is not equal to true -> duplicate
     *
     * @param {?} url
     * @param {?} http
     * @param {?} expectValue
     * @return {?}
     */
    function (url, http, expectValue) {
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            if (control.value) {
                return http.get(url, control.value).pipe(map((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) {
                    // compare value only here
                    if (res === expectValue) {
                        return null;
                    }
                    else {
                        return { duplicateError: true };
                    }
                }), (/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) {
                    return { duplicateError: true };
                })), catchError((/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) {
                    return null;
                })));
            }
            else {
                return new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    resolve(null);
                }));
            }
        });
    };
    /**
     * should not contain blank
     * */
    /**
     * should not contain blank
     *
     * @param {?} control
     * @return {?}
     */
    NgxValidators.isUrl = /**
     * should not contain blank
     *
     * @param {?} control
     * @return {?}
     */
    function (control) {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        /** @type {?} */
        var v = control.value;
        /* tslint:disable */
        return /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})).?)(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(v) ? null : { 'isUrlError': true };
        /* tslint:enable */
    };
    return NgxValidators;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxValidateService, ValidationErrorComponent, NgxValidateModule, NgxValidators };

//# sourceMappingURL=ngx-validate.js.map